libstdc++: __gnu_cxx::bitmap_allocator< _Tp > Class Template Reference

libstdc++

__gnu_cxx::bitmap_allocator< _Tp > Class Template Reference
Utilities » Memory » Allocators

`#include <bitmap_allocator.h>`

Inheritance diagram for __gnu_cxx::bitmap_allocator< _Tp >:
[legend]

## Public Types
typedef free_list::__mutex_type | __mutex_type
typedef const _Tp * | const_pointer
typedef const _Tp & | const_reference
typedef std::ptrdiff_t | difference_type
typedef _Tp * | pointer
typedef std::true_type | propagate_on_container_move_assignment
typedef _Tp & | reference
typedef std::size_t | size_type
typedef _Tp | value_type

## Public Member Functions
| bitmap_allocator (const bitmap_allocator &) noexcept
template<typename _Tp1>
| bitmap_allocator (const bitmap_allocator< _Tp1 > &) noexcept
pointer | _M_allocate_single_object ()
void | _M_deallocate_single_object (pointer __p) throw ()
const_pointer | address (const_reference __r) const noexcept
pointer | address (reference __r) const noexcept
pointer | allocate (size_type __n)
pointer | allocate (size_type __n, typename bitmap_allocator< void >::const_pointer)
template<typename _Up, typename... _Args>
void | construct (_Up *__p, _Args &&... __args)
void | deallocate (pointer __p, size_type __n) throw ()
template<typename _Up>
void | destroy (_Up *__p)
size_type | max_size () const noexcept

## Detailed Description

template<typename _Tp>
class __gnu_cxx::bitmap_allocator< _Tp >

Bitmap Allocator, primary template.

Definition at line 683 of file bitmap_allocator.h.

## Member Typedef Documentation

## ◆ __mutex_type

template<typename _Tp>

typedef free_list::__mutex_type __gnu_cxx::bitmap_allocator< _Tp >::__mutex_type

Definition at line 693 of file bitmap_allocator.h.

## ◆ const_pointer

template<typename _Tp>

typedef const _Tp* __gnu_cxx::bitmap_allocator< _Tp >::const_pointer

Definition at line 689 of file bitmap_allocator.h.

## ◆ const_reference

template<typename _Tp>

typedef const _Tp& __gnu_cxx::bitmap_allocator< _Tp >::const_reference

Definition at line 691 of file bitmap_allocator.h.

## ◆ difference_type

template<typename _Tp>

typedef std::ptrdiff_t __gnu_cxx::bitmap_allocator< _Tp >::difference_type

Definition at line 687 of file bitmap_allocator.h.

## ◆ pointer

template<typename _Tp>

typedef _Tp* __gnu_cxx::bitmap_allocator< _Tp >::pointer

Definition at line 688 of file bitmap_allocator.h.

## ◆ propagate_on_container_move_assignment

template<typename _Tp>

typedef std::true_type __gnu_cxx::bitmap_allocator< _Tp >::propagate_on_container_move_assignment

Definition at line 704 of file bitmap_allocator.h.

## ◆ reference

template<typename _Tp>

typedef _Tp& __gnu_cxx::bitmap_allocator< _Tp >::reference

Definition at line 690 of file bitmap_allocator.h.

## ◆ size_type

template<typename _Tp>

typedef std::size_t __gnu_cxx::bitmap_allocator< _Tp >::size_type

Definition at line 686 of file bitmap_allocator.h.

## ◆ value_type

template<typename _Tp>

typedef _Tp __gnu_cxx::bitmap_allocator< _Tp >::value_type

Definition at line 692 of file bitmap_allocator.h.

## Constructor & Destructor Documentation

## ◆ bitmap_allocator() [1/3]

template<typename _Tp>

__gnu_cxx::bitmap_allocator< _Tp >::bitmap_allocator | ( |  | ) |
| inlinenoexcept

Definition at line 1001 of file bitmap_allocator.h.

## ◆ bitmap_allocator() [2/3]

template<typename _Tp>

__gnu_cxx::bitmap_allocator< _Tp >::bitmap_allocator | ( | const bitmap_allocator< _Tp > & |  | ) |
| inlinenoexcept

Definition at line 1004 of file bitmap_allocator.h.

## ◆ bitmap_allocator() [3/3]

template<typename _Tp>
template<typename _Tp1>

__gnu_cxx::bitmap_allocator< _Tp >::bitmap_allocator | ( | const bitmap_allocator< _Tp1 > & |  | ) |
| inlinenoexcept

Definition at line 1008 of file bitmap_allocator.h.

## ◆ ~bitmap_allocator()

template<typename _Tp>

__gnu_cxx::bitmap_allocator< _Tp >::~bitmap_allocator | ( |  | ) |
| inlinenoexcept

Definition at line 1011 of file bitmap_allocator.h.

## Member Function Documentation

## ◆ _M_allocate_single_object()

template<typename _Tp>

pointer __gnu_cxx::bitmap_allocator< _Tp >::_M_allocate_single_object | ( |  | ) |
| inline

Allocates memory for a single object of size sizeof(_Tp).

Exceptions

  std::bad_alloc. | If memory cannot be allocated.

Complexity: Worst case complexity is O(N), but that is hardly ever hit. If and when this particular case is encountered, the next few cases are guaranteed to have a worst case complexity of O(1)! That's why this function performs very well on average. You can consider this function to have a complexity referred to commonly as: Amortized Constant time.

Definition at line 824 of file bitmap_allocator.h.

## ◆ _M_deallocate_single_object()

template<typename _Tp>

void __gnu_cxx::bitmap_allocator< _Tp >::_M_deallocate_single_object | ( | pointer | __p | ) |
throw | ( | ) |  |  |
| inline

Deallocates memory that belongs to a single object of size sizeof(_Tp).

Complexity: O(lg(N)), but the worst case is not hit often! This is because containers usually deallocate memory close to each other and this case is handled in O(1) time by the deallocate function.

Definition at line 915 of file bitmap_allocator.h.

## ◆ address() [1/2]

template<typename _Tp>

const_pointer __gnu_cxx::bitmap_allocator< _Tp >::address | ( | const_reference | __r | ) | const
| inlinenoexcept

Definition at line 1068 of file bitmap_allocator.h.

## ◆ address() [2/2]

template<typename _Tp>

pointer __gnu_cxx::bitmap_allocator< _Tp >::address | ( | reference | __r | ) | const
| inlinenoexcept

Definition at line 1064 of file bitmap_allocator.h.

## ◆ allocate() [1/2]

template<typename _Tp>

pointer __gnu_cxx::bitmap_allocator< _Tp >::allocate | ( | size_type | __n | ) |
| inlinenodiscard

Definition at line 1015 of file bitmap_allocator.h.

## ◆ allocate() [2/2]

template<typename _Tp>

pointer __gnu_cxx::bitmap_allocator< _Tp >::allocate | ( | size_type | __n,
|  | typename bitmap_allocator< void >::const_pointer | )
| inlinenodiscard

Definition at line 1039 of file bitmap_allocator.h.

## ◆ construct()

template<typename _Tp>
template<typename _Up, typename... _Args>

void __gnu_cxx::bitmap_allocator< _Tp >::construct | ( | _Up * | __p,
|  | _Args &&... | __args )
| inline

Definition at line 1078 of file bitmap_allocator.h.

## ◆ deallocate()

template<typename _Tp>

void __gnu_cxx::bitmap_allocator< _Tp >::deallocate | ( | pointer | __p,
|  | size_type | __n )
throw | ( | ) |  |  |
| inline

Definition at line 1043 of file bitmap_allocator.h.

## ◆ destroy()

template<typename _Tp>
template<typename _Up>

void __gnu_cxx::bitmap_allocator< _Tp >::destroy | ( | _Up * | __p | ) |
| inline

Definition at line 1083 of file bitmap_allocator.h.

## ◆ max_size()

template<typename _Tp>

size_type __gnu_cxx::bitmap_allocator< _Tp >::max_size | ( |  | ) | const
| inlinenoexcept

Definition at line 1072 of file bitmap_allocator.h.

The documentation for this class was generated from the following file:

- bitmap_allocator.h